﻿import socket as sk
import select as slc

hote = "127.0.0.1"
port = 12800
connexion = sk.socket()
connexion.bind((hote, port))
connexion.listen(5)
print("Le serveur écoute sur le port :", port)
serveur_actif = True
liste_clients = []
while serveur_actif :
    liste_demandes, wlist, xlist = slc.select([connexion], [], [], 0.05)
    for demande in liste_demandes :
        client, infos = demande.accept()
        print("Connexion du client", infos)
        liste_clients.append(client)
    liste_a_lire = []
    try :
        liste_a_lire, wlist, xlist = slc.select(liste_clients, [], [], 0.05)
    except slc.error:
        pass
    else :
        for client in liste_a_lire :
            msg_recu = client.recv(1024)
            infos = client.getpeername()
            print(infos, ":", msg_recu.decode())
            client.send(b"Ok")
            if msg_recu.decode() == "fin" :
                print(infos, "est parti !")
                liste_clients.remove(client)
                client.close()
            elif msg_recu.decode() == "stop" :
                serveur_actif = False
print("Fermeture des connexions")
for client in liste_clients :
    client.close()
connexion.close()